/*
	Commande Vectorielle Indirecte par Orientation du Flux Rotorique
	------------  reconfiguration complte Pour DS1104  ------------
	avec regulateur flou de vitesse et de Courant
	+ multi ctrl type ( class / flou )

	avec regul de position Treg=10*1ms, Proportionel
	avec stator ind flux orientation
	et defluxage progressif

	Grande Machine
	Lotfi BAGHLI			  19/06/1996	rev 27/03/1997

	reconfiguration complte Pour DS1104
	Ajout reception via RS232 UART de SpeedRef	+ Volatile declaration 30/05/2004
	light version Lotfi BAGHLI			  rev 12/12/2006

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#include <brtenv.h>                           /* basic real-time environment */
#include <math.h>		/* sin cos */
#include "ctrl.h"		/* Declaration des fonctions + macros + includes 
												Declaration de variables + initialisation*/

/*---------------------------------------------------------------------------*/
/* interrupt service routine for PWM sync interrupt */

void PWM_sync_interrupt(void)
{
	ds1104_bit_io_set(DS1104_DIO0 | DS1104_DIO1);
	
  RTLIB_TIC_START();                              /* start time measurement */
	ds1104_bit_io_clear(DS1104_DIO0);

	switch(countCurrent)
		{
		case 0	:	RegulI_Control();
							break;
		case 1	:	Regul_Vitesse();
							//old host_service(1, 0);															/* Data Acquisition service */
							/* read level of SW-FIFO */
							rec_fifo_level = dsser_receive_fifo_level(serCh);
							break;
		}
	if (++countCurrent==DS_IReg)	countCurrent=0;
// new host interface at dt=1e-4 s
	host_service(1, 0);	
	ds1104_bit_io_clear(DS1104_DIO1);
  exec_time = RTLIB_TIC_READ();
}

/*--- UART sub-interrupt handler --------------------------------------------*/
void Myserial_subint_handler(dsserChannel* serCh, const UInt32 subint_no)
{
  switch (subint_no)
		{
    case DSSER_TRIGGER_LEVEL_SUBINT:                   /* read received data */
//					rec_error = dsser_receive_term(serCh, rec_datalen, (UInt8*) rec_data, (UInt32 *) &rec_count, 0);
					rec_error = dsser_receive(serCh, rec_datalen, (UInt8*) rec_data, (UInt32 *) &rec_count);
					if (rec_count==1)
								{
								if (InIndex!=0 && (rec_data[0] & 0x80)==0x80)		InIndex=0;	// remet au dbut si caractre de controle
								InData[InIndex++]=rec_data[0];
								if (InIndex==3)	InIndex=0;
								if (InIndex==0 && (InData[1] & 0x80)==0 && (InData[2] & 0x80)==0 )
																{
																switch(InData[0])
																	{
																	case ID_ModeControleVitesse :	DataRef=InData[1] | (InData[2]<<7);
																							if (DataRef>8191)	DataRef-=16384;
																							// en rapport avec le programme d'envoi
																							if (DataRef>=-2400 && DataRef<=2400)	Wmref=DataRef*trm2rds/4.0;
																							break;
																	case ID_ModeControlePosition :	DataRef=InData[1] | (InData[2]<<7);
																							if (DataRef>8191)	DataRef-=16384;
																							// en rapport avec le programme d'envoi
																							if (DataRef>=-8000 && DataRef<=8000)	mposref=DataRef*TWOPI/4.0;
																							break;
																	case ID_ModeControle :	DataRef=InData[1];
																							if (DataRef==4)	PosControlFlag=1;	// Contrle Position
																									else				PosControlFlag=0;	// Contrle vitesse
																							break;
																	}																
																}
								}
					break;
//    case DSSER_TX_FIFO_EMPTY_SUBINT:                        /* transmit data */
//					trans_error = dsser_transmit(serCh, trans_datalen, (UInt8*) trans_data, (UInt32 *) &trans_count);
//					break;
		}
// new host interface for serial interrupt
	host_service(2, 0);	
}

/*---------------------------------------------------------------------------*/
void main(void)
{
  init();                             /* DS1104 and RTLib1104 initialization */
	msg_info_set(0, 0, "Systeme : MAS controle vectoriel avec pilotage par liaison srie, started.");
	/* init incremental encoder channel 1  : input signal for channel 1 via RS422 */
  ds1104_inc_init(1, DS1104_INC_MODE_RS422);
  ds1104_inc_set_idxmode(1, DS1104_INC_IDXMODE_OFF);

	/* config IO 0 et 1 output */
	ds1104_bit_io_init( DS1104_DIO0_OUT | DS1104_DIO1_OUT);
	ds1104_bit_io_clear(DS1104_DIO0 | DS1104_DIO1);

	/* config DAC */
	ds1104_dac_init( DS1104_DACMODE_TRANSPARENT);

  /* initialization of slave DSP communication */
  ds1104_slave_dsp_communication_init();

  /* init and start of 3-phase PWM generation on slave DSP */
  ds1104_slave_dsp_pwm3_init(task_id, MLIperiod, duty1, duty2, duty3, deadband, sync_pos);
  ds1104_slave_dsp_pwm3_start(task_id);
  /* registration of PWM duty cycle update command */
  ds1104_slave_dsp_pwm3_duty_write_register(task_id, &index);
  /* ADC Init and Sync */
   ds1104_adc_mux( 1); /* le 16 bit ADC sur channel 1) */
    /* 12 bits ADC 1 to 4 ie 2 to 5 are Courants Ias, Ibs et f.e.m. Ealphas et Ebetas */
   ds1104_adc_trigger_setup( 1, DS1104_TRIGGER_ENABLE); 
   ds1104_adc_trigger_setup( 2, DS1104_TRIGGER_ENABLE); 
   ds1104_adc_trigger_setup( 3, DS1104_TRIGGER_ENABLE); 
   ds1104_adc_trigger_setup( 4, DS1104_TRIGGER_ENABLE); 
   ds1104_adc_trigger_setup( 5, DS1104_TRIGGER_ENABLE); 
   ds1104_syncin_edge_setup( DS1104_SYNC_TRIGGER_RISING);

  /* initalize UART channel structure */
  serCh = dsser_init(DSSER_ONBOARD, 0, 64);
  /* install UART sub-interrupt handler */
  dsser_subint_handler_inst(serCh, (dsser_subint_handler_t)Myserial_subint_handler);
  /* configure the UART */
  dsser_config(serCh, DSSER_FIFO_MODE_OVERWRITE, 9600, 8, DSSER_1_STOPBIT, DSSER_NO_PARITY,
					DSSER_1_BYTE_TRIGGER_LEVEL, DSSER_DEFAULT_TRIGGER_LEVEL, DSSER_RS232);
  /* enable the required sub-interrupts (RX only) */
  dsser_subint_enable(serCh, DSSER_TRIGGER_LEVEL_SUBINT_MASK); // |  DSSER_TX_FIFO_EMPTY_SUBINT_MASK);
	
	/* initialization of PWM sync interrupt */
  ds1104_set_interrupt_vector(DS1104_INT_SLAVE_DSP_PWM,
                              (DS1104_Int_Handler_Type) &PWM_sync_interrupt, SAVE_REGS_ON);
  ds1104_enable_hardware_int(DS1104_INT_SLAVE_DSP_PWM);
  RTLIB_INT_ENABLE();
 /* Background tasks */
  while(1)
  {
    RTLIB_BACKGROUND_SERVICE();                        /* background service */
  }
}
	